/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20240109

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "parse.y"
#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#include "parse.h"
#include "textBuf.h"
#include "nedit.h"
#include "../util/rbTree.h"
#include "interpret.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#ifdef VMS
#include "../util/VMSparam.h"
#else
#ifndef __MVS__
#include <sys/param.h>
#endif
#endif /*VMS*/

#ifdef HAVE_DEBUG_H
#include "../debug.h"
#endif

/* Macros to add error processing to AddOp and AddSym calls */
#define ADD_OP(op) if (!AddOp(op, &ErrMsg)) return 1
#define ADD_SYM(sym) if (!AddSym(sym, &ErrMsg)) return 1
#define ADD_IMMED(val) if (!AddImmediate(val, &ErrMsg)) return 1
#define ADD_BR_OFF(to) if (!AddBranchOffset(to, &ErrMsg)) return 1
#define SET_BR_OFF(from, to) ((from)->value) = ((Inst *)(to)) - ((Inst *)(from))

/* Max. length for a string constant (... there shouldn't be a maximum) */
#define MAX_STRING_CONST_LEN 5000

static int yyerror(char *s);
static int yylex(void);
int yyparse(void);
static int follow(char expect, int yes, int no);
static int follow2(char expect1, int yes1, char expect2, int yes2, int no);
static int follow_non_whitespace(char expect, int yes, int no);
static Symbol *matchesActionRoutine(char **inPtr);

static char *ErrMsg;
static char *InPtr;
extern Inst *LoopStack[]; /* addresses of break, cont stmts */
extern Inst **LoopStackPtr;  /*  to fill at the end of a loop */

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 55 "parse.y"
typedef union YYSTYPE {
    Symbol *sym;
    Inst *inst;
    int nArgs;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 89 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define NUMBER 257
#define STRING 258
#define SYMBOL 259
#define DELETE 260
#define ARG_LOOKUP 261
#define IF 262
#define WHILE 263
#define ELSE 264
#define FOR 265
#define BREAK 266
#define CONTINUE 267
#define RETURN 268
#define IF_NO_ELSE 269
#define ADDEQ 270
#define SUBEQ 271
#define MULEQ 272
#define DIVEQ 273
#define MODEQ 274
#define ANDEQ 275
#define OREQ 276
#define CONCAT 277
#define OR 278
#define AND 279
#define GT 280
#define GE 281
#define LT 282
#define LE 283
#define EQ 284
#define NE 285
#define IN 286
#define UNARY_MINUS 287
#define NOT 288
#define INCR 289
#define DECR 290
#define POW 291
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    0,    0,   13,   13,   13,   12,   12,   14,
   14,   14,   14,   14,   16,   14,   14,   14,   14,   14,
   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
   15,   15,   15,   15,   15,   15,   10,    3,    3,    3,
    1,    1,    1,   17,   17,   19,   19,   18,   18,    9,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,    5,    4,    6,    2,    2,    7,    8,   11,
   11,
};
static const YYINT yylen[] = {                            2,
    2,    5,    4,    1,    5,    4,    1,    1,    2,    3,
    6,    9,    6,   10,    0,    9,    3,    3,    4,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    5,    6,
    6,    6,    6,    6,    6,    6,    6,    5,    5,    5,
    5,    4,    2,    2,    2,    2,    1,    0,    1,    3,
    0,    1,    3,    1,    2,    1,    4,    1,    4,    1,
    1,    1,    1,    4,    3,    4,    3,    1,    4,    3,
    3,    3,    3,    3,    3,    2,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    2,    2,    2,    2,
    2,    3,    1,    1,    1,    0,    1,    1,    1,    0,
    2,
};
static const YYINT yydefred[] = {                         0,
    4,    0,    0,    0,    0,    0,   93,   94,    0,    0,
    0,    0,    0,  100,  101,    0,    0,    0,    0,    8,
    0,    0,    0,   44,   46,    0,   58,    0,    0,  100,
  100,   61,   62,    0,    0,    0,    0,    0,    0,    0,
  100,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    9,  100,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   89,   91,
    0,    0,    0,    0,   88,   90,    0,    0,  100,    0,
   99,   98,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    3,    0,    0,    0,   49,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   42,    0,    0,
  100,    0,   67,    0,   65,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    2,    0,    0,    0,
  100,    0,    0,    0,    0,   64,   66,   69,    0,    0,
    0,    0,    0,   50,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   38,   39,  100,    0,    7,   15,    0,
   13,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   95,  100,  100,    0,  100,    0,    0,    0,  100,    0,
  100,   12,   16,    0,    0,   14,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  256,  293,  304,  259,  260,  262,  263,  265,  266,  267,
  268,  289,  290,  123,   10,  297,  298,  303,  305,  307,
  308,  312,   61,  289,  290,   40,  259,  311,   40,   10,
   10,  257,  258,  259,  261,   45,  288,  289,  290,   40,
   10,  310,  313,  259,  312,  259,  312,  304,   40,   40,
  270,  271,  272,  273,  274,  275,  276,  307,   10,   91,
  310,  294,  310,   91,  295,  313,  304,  304,  289,  290,
   40,   91,  313,  313,  259,  259,  310,  304,   10,  313,
  278,  279,  124,   38,  280,  281,  282,  283,  284,  285,
  286,   43,   45,   42,   47,   37,  291,   91,  300,  301,
   91,   91,  125,  305,  259,  296,  308,  295,  310,  310,
  310,  310,  310,  310,  310,  304,  294,   41,   44,  294,
   41,  294,   93,  313,   41,  304,  313,  313,  313,  313,
  313,  313,  313,  313,  313,  313,  313,  313,  313,  313,
  313,  294,  313,  313,  294,  294,  125,  286,   59,   44,
   41,   93,  310,   93,  304,   41,   93,   93,   93,   93,
  302,  313,  295,  308,  304,   61,  270,  271,  272,  273,
  274,  275,  276,  289,  290,  123,  306,  307,   41,   59,
  306,  310,  310,  310,  310,  310,  310,  310,  310,  304,
  264,  299,  309,  296,  125,  305,  304,  304,   41,  304,
  125,  306,  306,  304,  304,  306,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                          2,
   62,   65,  106,   16,   17,  192,   99,  100,  161,   18,
    3,   19,  177,  178,   21,  193,   63,   28,   22,   43,
};
static const YYINT yysindex[] = {                      -242,
    0,    0,  221,    6, -243,  -15,    0,    0,   32,   42,
  603, -209, -204,    0,    0,   54,   58,  768, 1179,    0,
   77,   22,  843,    0,    0,  843,    0,   38,  843,    0,
    0,    0,    0,    8,   44,  843,  843, -150, -142,  843,
    0,  747, 1368,    0,   46,    0,   49,  369,  101,  843,
  843,  843,  843,  843,  843,  843,  843,    0,    0,  843,
  843,  -26,  843,  843,   82, 1368,  121,  121,    0,    0,
  843,  975,  -87,  -87,    0,    0,  837,  121,    0, 1368,
    0,    0,  843,  843,  843,  843,  843,  843,  843,  843,
  843,  843,  843,  843,  843,  843,  843,  843,  843,  843,
  843,  843,    0,  328,  -31,  -27,    0,  104,  843,  843,
  843,  843,  843,  843,  843,  121,  -22,    0,  843,  -21,
    0,  -17,    0,  -35,    0,  121,   65,  163,   -9,   -9,
   -9,   -9,   -9,   -9,   -9,    2,    2,  -87,  -87,  -87,
  -87,   -7,   23, 1250,   39,   40,    0,  843,  843,  504,
    0,  624,  843,    0,  292,    0,    0,    0,    0,    0,
  110, 1368,   94,    0,  292,  843,  843,  843,  843,  843,
  843,  843,  843,    0,    0,    0, -110,    0,    0,  504,
    0,  843,  843,  843,  843,  843,  843,  843,  843,  665,
    0,    0,    0,   55,    0,  464,  292,  292,    0,  121,
    0,    0,    0,  292,  121,    0,
};
static const YYINT yyrindex[] = {                       700,
    0,    0,    0,  -91,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  155,    0,
    0,    0,    0,    0,    0,   56,    0,    0,  116,    0,
    0,    0,    0,  383,  128,    0,    0,    0,    0,    0,
    0,    0,  179,   10,    0,  108,    0,    0,  -18,  116,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   51,
   47,    0,   -1,   51,    0,  -28,    1,   11,    0,    0,
   56,    0,  419,  455,    0,    0,    0,   21,    0,  431,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   51,    0,    0,
   51,   51,    0,    0,  -91,    0,    0,    0,   75,   80,
  117,  481,  503,  568,  611,   53,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   63, 1342, 1337,  899,  934,
  969, 1197, 1232, 1267, 1302,  827,  863,  491,  527,  563,
  791,    0, 1377,  877,    0,    0,    0,    0,  127,    0,
    0,   69,   18,  118,    0,    0,    0,    0,  391,  539,
    0,  122,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  115,    0,    0,   81,
    0,  613,  755,  815,  875,  932,  936,  940,  942,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   73,
    0,    0,    0,    0,  105,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
  444,  -45,  -16,    0,    0,    0,    0,    0,    0,    0,
 1272,  -42,   37,   26,  -30,    0,   24,    0,  129, 1632,
};
#define YYTABLESIZE 1821
static const YYINT yytable[] = {                         56,
   17,   96,   84,   98,  108,  104,   94,   92,   26,   93,
   18,   95,   97,    1,  118,   27,  150,  119,  107,   43,
   20,  119,  119,  156,   29,   48,  119,   96,   20,   23,
   97,  149,   94,   92,   42,   93,  119,   95,   96,   52,
   48,   30,   52,   94,   58,   26,   61,   71,   95,   44,
   43,   31,   10,   43,   46,   98,   21,  157,   53,   96,
   84,   53,   19,   77,   94,   92,   23,   93,   43,   95,
  152,  154,    6,   20,  109,  110,  111,  112,  113,  114,
  115,   98,  119,  119,   22,  158,   59,   21,   83,   23,
   21,   52,   98,   49,   51,  199,   51,   50,  150,   51,
   56,   96,   84,  163,    5,   21,   94,   92,   75,   93,
   53,   95,   60,   98,   11,   22,   76,   45,   22,  164,
   23,   48,  121,   23,   48,   17,   24,   29,   64,   58,
   15,  159,  160,   22,   72,   18,  101,   68,   23,  102,
   45,   47,  153,   51,  151,   20,   83,  196,   45,  107,
  179,   45,  180,  191,    1,   98,   96,   24,   29,   57,
   24,   29,   60,  194,   68,   68,   45,   68,   68,   68,
   68,   68,   68,    0,   68,   24,   29,   10,   47,   47,
   47,   47,   47,   47,   47,   96,   68,   19,   54,  182,
  183,  184,  185,  186,  187,  188,  189,    6,   56,   96,
    0,  181,    0,   97,   94,   92,    0,   93,   59,   95,
    0,    0,    0,    0,    0,   20,    0,    0,   54,   54,
   68,   58,   54,    0,    0,    0,    0,    0,    0,    5,
   15,    0,    0,  202,  203,    0,    0,   54,    0,   11,
  206,    0,   81,   82,   85,   86,   87,   88,   89,   90,
   91,   68,    0,   98,  148,   97,    0,   24,   25,   17,
   17,    0,   17,   17,   17,   17,   17,   17,   17,   18,
   18,   54,   18,   18,   18,   18,   18,   18,   18,   20,
   20,   97,   20,   20,   20,   20,   20,   20,   20,   17,
   17,    0,   97,    0,   24,   25,   69,   70,    0,   18,
   18,   15,   85,   86,   87,   88,   89,   90,   91,   20,
   20,   10,   10,   97,   10,   10,   10,   10,   10,   10,
   10,   19,   19,    0,   19,   19,   19,   19,   19,   19,
   19,    6,    6,    0,    6,    6,    6,    6,    6,    6,
    6,   10,   10,   14,   85,   86,   87,   88,   89,   90,
   91,   19,   19,    0,    0,   97,    0,    0,    0,  105,
    5,    6,    6,    5,    5,    0,    5,    5,    5,    5,
    5,    5,    5,   11,   11,    0,   11,   11,   15,   11,
   11,   11,   11,    0,   68,   68,   68,    0,   68,   12,
   13,    0,   63,    5,    5,    0,    0,    0,    0,    0,
   40,    0,    0,   11,   11,   68,   68,   68,   68,   68,
   68,   68,   68,   68,  176,   68,   68,   68,   68,   63,
   63,    0,    0,   63,   63,   63,   63,   63,   76,   63,
    0,   40,    0,    0,   40,   54,   54,   54,    0,   54,
   55,   63,   85,   86,   87,   88,   89,   90,   91,   40,
    0,    0,  147,   97,    0,   76,   76,    0,   76,   76,
   76,   76,   76,   76,   87,   76,   54,   54,   54,    0,
   55,   55,    0,   63,   55,   63,    0,   76,    0,    4,
    5,   57,    6,    7,    0,    8,    9,   10,   11,   55,
   25,   87,   87,  103,   87,   87,   87,   87,   87,   87,
   72,   87,    0,  117,    0,    0,   63,  120,    0,   12,
   13,   76,   26,   87,  122,    0,    0,    0,    0,    0,
    0,   25,    0,   55,   25,    0,    0,   72,   72,    0,
   72,   72,   72,   72,   72,   72,   73,   72,    0,   25,
    0,  142,   76,   26,  145,  146,   26,   87,   41,   72,
    4,    5,    0,    6,    7,    0,    8,    9,   10,   11,
    0,   26,    0,   73,   73,    0,   73,   73,   73,   73,
   73,   73,   74,   73,    0,    0,    0,   27,   87,   41,
   12,   13,   41,   72,    0,   73,    4,    5,  201,    6,
    7,    0,    8,    9,   10,   11,    0,   41,    0,   74,
   74,    0,   74,   74,   74,   74,   74,   74,   27,   74,
    0,   27,   41,    0,   72,    0,   12,   13,    0,   73,
   28,   74,   30,    0,    0,    0,   27,    4,    5,   57,
    6,    7,    0,    8,    9,   10,   11,    0,    0,   63,
   63,   63,   40,   63,    0,    0,    0,   36,    0,    0,
   73,   28,    0,   30,   28,   74,   30,   12,   13,    0,
   63,   63,   63,   63,   63,   63,   63,   63,   63,   28,
   63,   30,    0,   63,   15,   76,   76,   76,    0,   76,
    0,    0,    0,    0,  166,    0,   74,   55,   55,   55,
    0,   55,    0,    0,    0,    0,   76,   76,   76,   76,
   76,   76,   76,   76,   76,    0,   76,   76,   76,  100,
    0,   87,   87,   87,    0,   87,    0,    0,   55,   55,
   55,    0,    4,    5,    0,    6,    7,    0,    8,    9,
   10,   11,   87,   87,   87,   87,   87,   87,   87,   87,
   87,    0,   87,   87,   87,    0,    0,   72,   72,   72,
    0,   72,   12,   13,    0,    0,   79,    0,    0,    0,
    0,    0,    4,    5,   31,    0,    0,    0,   72,   72,
   72,   72,   72,   72,   72,   72,   72,    0,   72,   72,
   72,    0,    0,   73,   73,   73,   40,   73,    0,  195,
    0,   36,   12,   13,    0,   31,    0,    0,   31,    0,
   75,    0,    0,    0,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   31,   73,   73,   73,    0,    0,   74,
   74,   74,  100,   74,   32,    0,    0,   75,   75,    0,
   75,   75,   75,   75,   75,   75,   70,   75,    0,    0,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   75,
   74,   74,   74,    0,    0,   32,    0,    0,   32,   32,
   33,   34,    0,   35,   70,    0,   70,   70,    0,   70,
   70,   70,   71,   32,    0,    0,   40,  125,    0,    0,
    0,   36,   40,   75,   33,   70,   86,   36,    0,    0,
   37,   38,   39,  167,  168,  169,  170,  171,  172,  173,
   71,    0,   71,   71,    0,   71,   71,   71,   77,    0,
    0,    0,  174,  175,   75,   33,   86,   86,   33,   70,
   86,   71,    0,    4,    5,    0,    6,    7,    0,    8,
    9,   10,   11,   33,    0,   86,   77,    0,   77,   77,
    0,   34,   77,   78,    0,   35,    0,    0,    0,   36,
   70,   37,    0,   12,   13,   71,    0,   77,  100,  100,
    0,  100,  100,    0,  100,  100,  100,  100,    0,   86,
    0,   78,   34,   78,   78,   34,   35,   78,   79,   35,
   36,    0,   37,   36,    0,   37,   71,    0,  100,  100,
   34,   77,   78,    0,   35,    0,    0,    0,   36,    0,
   37,    0,    0,   32,   33,   34,   79,   35,   79,   79,
    0,    0,   79,    0,   40,    0,    0,    0,    0,   36,
    0,    0,   77,    0,    0,    0,   78,   79,    0,    0,
    0,    0,    0,    0,   37,   38,   39,   51,   52,   53,
   54,   55,   56,   57,    0,    0,    0,   75,   75,   75,
    0,   75,    0,    0,    0,    0,    0,   78,    0,    0,
    0,   79,    0,    0,    0,    0,    0,  123,   75,   75,
   75,   75,   75,   75,   75,   75,   75,    0,   75,   75,
   75,    0,    0,   70,   70,   70,    0,   70,    0,    0,
    0,    0,   79,   32,   33,   34,    0,   35,    0,   32,
   33,   34,    0,   35,   70,   70,   70,   70,   70,   70,
   70,   70,   70,    0,   70,   70,   70,    0,    0,   71,
   71,   71,    0,   71,   37,   38,   39,    0,    0,    0,
   37,   38,   39,   86,   86,   86,    0,   86,    0,    0,
   71,   71,   71,   71,   71,   71,   71,   71,   71,    0,
   71,   71,   71,    0,   86,   77,   77,   77,    0,   77,
    0,    0,    0,    0,   86,   86,   86,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   77,   77,   77,   77,
   77,   77,   77,   77,   77,    0,   77,   77,   77,    0,
   78,   78,   78,    0,   78,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   80,    0,    0,    0,
    0,   78,   78,   78,   78,   78,   78,   78,   78,   78,
    0,   78,   78,   78,    0,   79,   79,   79,    0,   79,
    0,   32,   33,   34,   80,   35,   80,   80,    0,    0,
   80,   81,    0,    0,    0,    0,   79,   79,   79,   79,
   79,   79,   79,   79,   79,   80,   79,   79,   79,    0,
    0,    0,   37,   38,   39,    0,    0,    0,    0,   81,
    0,   81,   81,    0,    0,   81,   82,    0,    0,    0,
    0,    0,    0,    0,    0,   48,   96,   84,    0,   80,
   81,   94,   92,    0,   93,    0,   95,    0,    0,    0,
    0,   67,   68,    0,   82,    0,   82,   82,    0,    0,
   82,   92,   78,    0,    0,    0,    0,    0,    0,    0,
   80,    0,    0,    0,   81,   82,    0,    0,    0,    0,
  116,    0,    0,    0,    0,    0,    0,    0,    0,   92,
   98,   92,   92,    0,    0,   92,   83,    0,    0,    0,
  126,   84,    0,    0,    0,   81,    0,    0,    0,   82,
   92,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   83,   83,    0,   83,   83,    0,    0,
   83,   84,   84,    0,    0,   84,   85,    0,    0,    0,
   82,    0,  155,    0,   92,   83,    0,    0,    0,    0,
   84,    0,    0,    0,   96,   84,    0,    0,    0,   94,
   92,    0,   93,    0,   95,    0,   85,   85,    0,    0,
   85,    0,  165,    0,    0,   92,    0,    0,    0,   83,
    0,    0,    0,    0,   84,   85,    0,    4,    5,    0,
    6,    7,    0,    8,    9,   10,   11,  190,    0,    0,
    0,    0,    0,   80,   80,   80,    0,   80,   98,    0,
   83,    0,    0,  197,  198,   84,  200,   12,   13,   85,
  204,    0,  205,    0,   80,   80,   80,   80,   80,   80,
   80,   80,   80,    0,   80,   80,   80,    0,   81,   81,
   81,   83,   81,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   81,
   81,   81,   81,   81,   81,   81,   81,   81,    0,   81,
   81,   81,    0,   82,   82,   82,    0,   82,   82,   85,
   86,   87,   88,   89,   90,   91,    0,    0,    0,    0,
   97,    0,    0,    0,   82,   82,   82,   82,   82,   82,
   82,   82,   82,    0,   82,   82,   82,    0,   92,   92,
   92,    0,   92,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   92,
   92,   92,   92,   92,   92,   92,   92,   92,    0,   92,
   92,   92,    0,   83,   83,   83,    0,   83,   84,   84,
   84,    0,   84,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   83,   83,    0,    0,    0,   84,
   84,    0,    0,    0,   83,   83,   83,    0,    0,   84,
   84,   84,    0,   85,   85,   85,    0,   85,    0,    0,
    0,    0,    0,    0,    0,   81,   82,   85,   86,   87,
   88,   89,   90,   91,   85,   85,    0,    0,   97,    0,
   66,    0,    0,    0,   85,   85,   85,   73,   74,    0,
    0,    0,    0,   80,    0,    0,    0,    0,    0,    0,
    0,   66,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   80,    0,   80,    0,    0,    0,    0,    0,
    0,    0,    0,  124,    0,    0,    0,    0,   80,    0,
    0,    0,    0,    0,  127,  128,  129,  130,  131,  132,
  133,  134,  135,  136,  137,  138,  139,  140,  141,    0,
  143,  144,    0,    0,    0,    0,    0,    0,    0,    0,
   80,   80,   80,   80,   80,   80,   80,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  162,
   66,    0,    0,    0,   80,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   80,   80,   80,   80,   80,   80,   80,
   80,
};
static const YYINT yycheck[] = {                         91,
    0,   37,   38,   91,   50,   48,   42,   43,   40,   45,
    0,   47,   41,  256,   41,  259,   44,   44,   49,   10,
    0,   44,   44,   41,   40,   44,   44,   37,    3,   61,
   59,   59,   42,   43,   11,   45,   44,   47,   37,   41,
   59,   10,   44,   42,   19,   40,   23,   40,   47,  259,
   41,   10,    0,   44,  259,   91,   10,   93,   41,   37,
   38,   44,    0,   40,   42,   43,   61,   45,   59,   47,
   93,   93,    0,   48,   51,   52,   53,   54,   55,   56,
   57,   91,   44,   44,   10,   93,   10,   41,  124,   10,
   44,   93,   91,   40,   44,   41,   41,   40,   44,   44,
   91,   37,   38,  149,    0,   59,   42,   43,  259,   45,
   93,   47,   91,   91,    0,   41,  259,   10,   44,  150,
   41,   41,   41,   44,   44,  125,   10,   10,   91,  104,
   10,   93,   93,   59,   91,  125,   91,   10,   59,   91,
   12,   13,  119,   93,   41,  125,  124,  190,   41,  180,
   41,   44,   59,  264,    0,   91,   41,   41,   41,   91,
   44,   44,   41,  180,   37,   38,   59,   40,   41,   42,
   43,   44,   45,   -1,   47,   59,   59,  125,  270,  271,
  272,  273,  274,  275,  276,   59,   59,  125,   10,  166,
  167,  168,  169,  170,  171,  172,  173,  125,   91,   37,
   -1,  165,   -1,  291,   42,   43,   -1,   45,   91,   47,
   -1,   -1,   -1,   -1,   -1,  190,   -1,   -1,   40,   41,
   93,  196,   44,   -1,   -1,   -1,   -1,   -1,   -1,  125,
   10,   -1,   -1,  197,  198,   -1,   -1,   59,   -1,  125,
  204,   -1,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  124,   -1,   91,  286,  291,   -1,  289,  290,  259,
  260,   -1,  262,  263,  264,  265,  266,  267,  268,  259,
  260,   93,  262,  263,  264,  265,  266,  267,  268,  259,
  260,  291,  262,  263,  264,  265,  266,  267,  268,  289,
  290,   -1,  291,   -1,  289,  290,  289,  290,   -1,  289,
  290,   10,  280,  281,  282,  283,  284,  285,  286,  289,
  290,  259,  260,  291,  262,  263,  264,  265,  266,  267,
  268,  259,  260,   -1,  262,  263,  264,  265,  266,  267,
  268,  259,  260,   -1,  262,  263,  264,  265,  266,  267,
  268,  289,  290,  123,  280,  281,  282,  283,  284,  285,
  286,  289,  290,   -1,   -1,  291,   -1,   -1,   -1,  259,
  260,  289,  290,  259,  260,   -1,  262,  263,  264,  265,
  266,  267,  268,  259,  260,   -1,  262,  263,   10,  265,
  266,  267,  268,   -1,  257,  258,  259,   -1,  261,  289,
  290,   -1,   10,  289,  290,   -1,   -1,   -1,   -1,   -1,
   10,   -1,   -1,  289,  290,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  123,  288,  289,  290,  291,   37,
   38,   -1,   -1,   41,   42,   43,   44,   45,   10,   47,
   -1,   41,   -1,   -1,   44,  257,  258,  259,   -1,  261,
   10,   59,  280,  281,  282,  283,  284,  285,  286,   59,
   -1,   -1,  125,  291,   -1,   37,   38,   -1,   40,   41,
   42,   43,   44,   45,   10,   47,  288,  289,  290,   -1,
   40,   41,   -1,   91,   44,   93,   -1,   59,   -1,  259,
  260,   91,  262,  263,   -1,  265,  266,  267,  268,   59,
   10,   37,   38,  125,   40,   41,   42,   43,   44,   45,
   10,   47,   -1,   60,   -1,   -1,  124,   64,   -1,  289,
  290,   93,   10,   59,   71,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   -1,   93,   44,   -1,   -1,   37,   38,   -1,
   40,   41,   42,   43,   44,   45,   10,   47,   -1,   59,
   -1,   98,  124,   41,  101,  102,   44,   93,   10,   59,
  259,  260,   -1,  262,  263,   -1,  265,  266,  267,  268,
   -1,   59,   -1,   37,   38,   -1,   40,   41,   42,   43,
   44,   45,   10,   47,   -1,   -1,   -1,   10,  124,   41,
  289,  290,   44,   93,   -1,   59,  259,  260,  125,  262,
  263,   -1,  265,  266,  267,  268,   -1,   59,   -1,   37,
   38,   -1,   40,   41,   42,   43,   44,   45,   41,   47,
   -1,   44,   10,   -1,  124,   -1,  289,  290,   -1,   93,
   10,   59,   10,   -1,   -1,   -1,   59,  259,  260,   91,
  262,  263,   -1,  265,  266,  267,  268,   -1,   -1,  257,
  258,  259,   40,  261,   -1,   -1,   -1,   45,   -1,   -1,
  124,   41,   -1,   41,   44,   93,   44,  289,  290,   -1,
  278,  279,  280,  281,  282,  283,  284,  285,  286,   59,
  288,   59,   -1,  291,   10,  257,  258,  259,   -1,  261,
   -1,   -1,   -1,   -1,   61,   -1,  124,  257,  258,  259,
   -1,  261,   -1,   -1,   -1,   -1,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   -1,  288,  289,  290,   10,
   -1,  257,  258,  259,   -1,  261,   -1,   -1,  288,  289,
  290,   -1,  259,  260,   -1,  262,  263,   -1,  265,  266,
  267,  268,  278,  279,  280,  281,  282,  283,  284,  285,
  286,   -1,  288,  289,  290,   -1,   -1,  257,  258,  259,
   -1,  261,  289,  290,   -1,   -1,   10,   -1,   -1,   -1,
   -1,   -1,  259,  260,   10,   -1,   -1,   -1,  278,  279,
  280,  281,  282,  283,  284,  285,  286,   -1,  288,  289,
  290,   -1,   -1,  257,  258,  259,   40,  261,   -1,  125,
   -1,   45,  289,  290,   -1,   41,   -1,   -1,   44,   -1,
   10,   -1,   -1,   -1,  278,  279,  280,  281,  282,  283,
  284,  285,  286,   59,  288,  289,  290,   -1,   -1,  257,
  258,  259,  123,  261,   10,   -1,   -1,   37,   38,   -1,
   40,   41,   42,   43,   44,   45,   10,   47,   -1,   -1,
  278,  279,  280,  281,  282,  283,  284,  285,  286,   59,
  288,  289,  290,   -1,   -1,   41,   -1,   -1,   44,  257,
  258,  259,   -1,  261,   38,   -1,   40,   41,   -1,   43,
   44,   45,   10,   59,   -1,   -1,   40,   41,   -1,   -1,
   -1,   45,   40,   93,   10,   59,   10,   45,   -1,   -1,
  288,  289,  290,  270,  271,  272,  273,  274,  275,  276,
   38,   -1,   40,   41,   -1,   43,   44,   45,   10,   -1,
   -1,   -1,  289,  290,  124,   41,   40,   41,   44,   93,
   44,   59,   -1,  259,  260,   -1,  262,  263,   -1,  265,
  266,  267,  268,   59,   -1,   59,   38,   -1,   40,   41,
   -1,   10,   44,   10,   -1,   10,   -1,   -1,   -1,   10,
  124,   10,   -1,  289,  290,   93,   -1,   59,  259,  260,
   -1,  262,  263,   -1,  265,  266,  267,  268,   -1,   93,
   -1,   38,   41,   40,   41,   44,   41,   44,   10,   44,
   41,   -1,   41,   44,   -1,   44,  124,   -1,  289,  290,
   59,   93,   59,   -1,   59,   -1,   -1,   -1,   59,   -1,
   59,   -1,   -1,  257,  258,  259,   38,  261,   40,   41,
   -1,   -1,   44,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,  124,   -1,   -1,   -1,   93,   59,   -1,   -1,
   -1,   -1,   -1,   -1,  288,  289,  290,  270,  271,  272,
  273,  274,  275,  276,   -1,   -1,   -1,  257,  258,  259,
   -1,  261,   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   93,  278,  279,
  280,  281,  282,  283,  284,  285,  286,   -1,  288,  289,
  290,   -1,   -1,  257,  258,  259,   -1,  261,   -1,   -1,
   -1,   -1,  124,  257,  258,  259,   -1,  261,   -1,  257,
  258,  259,   -1,  261,  278,  279,  280,  281,  282,  283,
  284,  285,  286,   -1,  288,  289,  290,   -1,   -1,  257,
  258,  259,   -1,  261,  288,  289,  290,   -1,   -1,   -1,
  288,  289,  290,  257,  258,  259,   -1,  261,   -1,   -1,
  278,  279,  280,  281,  282,  283,  284,  285,  286,   -1,
  288,  289,  290,   -1,  278,  257,  258,  259,   -1,  261,
   -1,   -1,   -1,   -1,  288,  289,  290,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   -1,  288,  289,  290,   -1,
  257,  258,  259,   -1,  261,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,
   -1,  278,  279,  280,  281,  282,  283,  284,  285,  286,
   -1,  288,  289,  290,   -1,  257,  258,  259,   -1,  261,
   -1,  257,  258,  259,   38,  261,   40,   41,   -1,   -1,
   44,   10,   -1,   -1,   -1,   -1,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   59,  288,  289,  290,   -1,
   -1,   -1,  288,  289,  290,   -1,   -1,   -1,   -1,   38,
   -1,   40,   41,   -1,   -1,   44,   10,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   14,   37,   38,   -1,   93,
   59,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   30,   31,   -1,   38,   -1,   40,   41,   -1,   -1,
   44,   10,   41,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,   -1,   -1,   -1,   93,   59,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   38,
   91,   40,   41,   -1,   -1,   44,   10,   -1,   -1,   -1,
   79,   10,   -1,   -1,   -1,  124,   -1,   -1,   -1,   93,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   38,   -1,   40,   41,   -1,   -1,
   44,   40,   41,   -1,   -1,   44,   10,   -1,   -1,   -1,
  124,   -1,  121,   -1,   93,   59,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,   40,   41,   -1,   -1,
   44,   -1,  151,   -1,   -1,  124,   -1,   -1,   -1,   93,
   -1,   -1,   -1,   -1,   93,   59,   -1,  259,  260,   -1,
  262,  263,   -1,  265,  266,  267,  268,  176,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,   -1,  261,   91,   -1,
  124,   -1,   -1,  192,  193,  124,  195,  289,  290,   93,
  199,   -1,  201,   -1,  278,  279,  280,  281,  282,  283,
  284,  285,  286,   -1,  288,  289,  290,   -1,  257,  258,
  259,  124,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,
  279,  280,  281,  282,  283,  284,  285,  286,   -1,  288,
  289,  290,   -1,  257,  258,  259,   -1,  261,  279,  280,
  281,  282,  283,  284,  285,  286,   -1,   -1,   -1,   -1,
  291,   -1,   -1,   -1,  278,  279,  280,  281,  282,  283,
  284,  285,  286,   -1,  288,  289,  290,   -1,  257,  258,
  259,   -1,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,
  279,  280,  281,  282,  283,  284,  285,  286,   -1,  288,
  289,  290,   -1,  257,  258,  259,   -1,  261,  257,  258,
  259,   -1,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  278,  279,   -1,   -1,   -1,  278,
  279,   -1,   -1,   -1,  288,  289,  290,   -1,   -1,  288,
  289,  290,   -1,  257,  258,  259,   -1,  261,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  278,  279,   -1,   -1,  291,   -1,
   29,   -1,   -1,   -1,  288,  289,  290,   36,   37,   -1,
   -1,   -1,   -1,   42,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   50,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   72,   -1,   -1,   -1,   -1,   77,   -1,
   -1,   -1,   -1,   -1,   83,   84,   85,   86,   87,   88,
   89,   90,   91,   92,   93,   94,   95,   96,   97,   -1,
   99,  100,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  109,  110,  111,  112,  113,  114,  115,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  148,
  149,   -1,   -1,   -1,  153,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  182,  183,  184,  185,  186,  187,  188,
  189,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
};
#endif
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 291
#define YYUNDFTOKEN 314
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,0,0,0,
0,0,0,"';'",0,"'='",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",
"'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error","NUMBER","STRING","SYMBOL","DELETE",
"ARG_LOOKUP","IF","WHILE","ELSE","FOR","BREAK","CONTINUE","RETURN","IF_NO_ELSE",
"ADDEQ","SUBEQ","MULEQ","DIVEQ","MODEQ","ANDEQ","OREQ","CONCAT","OR","AND","GT",
"GE","LT","LE","EQ","NE","IN","UNARY_MINUS","NOT","INCR","DECR","POW","$accept",
"program","arglist","cond","comastmts","for","while","else","and","or",
"arrayexpr","evalsym","blank","stmts","block","stmt","simpstmt","$$1","expr",
"arraylv","initarraylv","numexpr","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : program",
"program : blank stmts",
"program : blank '{' blank stmts '}'",
"program : blank '{' blank '}'",
"program : error",
"block : '{' blank stmts '}' blank",
"block : '{' blank '}' blank",
"block : stmt",
"stmts : stmt",
"stmts : stmts stmt",
"stmt : simpstmt '\\n' blank",
"stmt : IF '(' cond ')' blank block",
"stmt : IF '(' cond ')' blank block else blank block",
"stmt : while '(' cond ')' blank block",
"stmt : for '(' comastmts ';' cond ';' comastmts ')' blank block",
"$$1 :",
"stmt : for '(' SYMBOL IN arrayexpr ')' $$1 blank block",
"stmt : BREAK '\\n' blank",
"stmt : CONTINUE '\\n' blank",
"stmt : RETURN expr '\\n' blank",
"stmt : RETURN '\\n' blank",
"simpstmt : SYMBOL '=' expr",
"simpstmt : evalsym ADDEQ expr",
"simpstmt : evalsym SUBEQ expr",
"simpstmt : evalsym MULEQ expr",
"simpstmt : evalsym DIVEQ expr",
"simpstmt : evalsym MODEQ expr",
"simpstmt : evalsym ANDEQ expr",
"simpstmt : evalsym OREQ expr",
"simpstmt : DELETE arraylv '[' arglist ']'",
"simpstmt : initarraylv '[' arglist ']' '=' expr",
"simpstmt : initarraylv '[' arglist ']' ADDEQ expr",
"simpstmt : initarraylv '[' arglist ']' SUBEQ expr",
"simpstmt : initarraylv '[' arglist ']' MULEQ expr",
"simpstmt : initarraylv '[' arglist ']' DIVEQ expr",
"simpstmt : initarraylv '[' arglist ']' MODEQ expr",
"simpstmt : initarraylv '[' arglist ']' ANDEQ expr",
"simpstmt : initarraylv '[' arglist ']' OREQ expr",
"simpstmt : initarraylv '[' arglist ']' INCR",
"simpstmt : initarraylv '[' arglist ']' DECR",
"simpstmt : INCR initarraylv '[' arglist ']'",
"simpstmt : DECR initarraylv '[' arglist ']'",
"simpstmt : SYMBOL '(' arglist ')'",
"simpstmt : INCR SYMBOL",
"simpstmt : SYMBOL INCR",
"simpstmt : DECR SYMBOL",
"simpstmt : SYMBOL DECR",
"evalsym : SYMBOL",
"comastmts :",
"comastmts : simpstmt",
"comastmts : comastmts ',' simpstmt",
"arglist :",
"arglist : expr",
"arglist : arglist ',' expr",
"expr : numexpr",
"expr : expr numexpr",
"initarraylv : SYMBOL",
"initarraylv : initarraylv '[' arglist ']'",
"arraylv : SYMBOL",
"arraylv : arraylv '[' arglist ']'",
"arrayexpr : numexpr",
"numexpr : NUMBER",
"numexpr : STRING",
"numexpr : SYMBOL",
"numexpr : SYMBOL '(' arglist ')'",
"numexpr : '(' expr ')'",
"numexpr : ARG_LOOKUP '[' numexpr ']'",
"numexpr : ARG_LOOKUP '[' ']'",
"numexpr : ARG_LOOKUP",
"numexpr : numexpr '[' arglist ']'",
"numexpr : numexpr '+' numexpr",
"numexpr : numexpr '-' numexpr",
"numexpr : numexpr '*' numexpr",
"numexpr : numexpr '/' numexpr",
"numexpr : numexpr '%' numexpr",
"numexpr : numexpr POW numexpr",
"numexpr : '-' numexpr",
"numexpr : numexpr GT numexpr",
"numexpr : numexpr GE numexpr",
"numexpr : numexpr LT numexpr",
"numexpr : numexpr LE numexpr",
"numexpr : numexpr EQ numexpr",
"numexpr : numexpr NE numexpr",
"numexpr : numexpr '&' numexpr",
"numexpr : numexpr '|' numexpr",
"numexpr : numexpr and numexpr",
"numexpr : numexpr or numexpr",
"numexpr : NOT numexpr",
"numexpr : INCR SYMBOL",
"numexpr : SYMBOL INCR",
"numexpr : DECR SYMBOL",
"numexpr : SYMBOL DECR",
"numexpr : numexpr IN numexpr",
"while : WHILE",
"for : FOR",
"else : ELSE",
"cond :",
"cond : numexpr",
"and : AND",
"or : OR",
"blank :",
"blank : blank '\\n'",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 441 "parse.y"
 /* User Subroutines Section */


/*
** Parse a null terminated string and create a program from it (this is the
** parser entry point).  The program created by this routine can be
** executed using ExecuteProgram.  Returns program on success, or NULL
** on failure.  If the command failed, the error message is returned
** as a pointer to a static string in msg, and the length of the string up
** to where parsing failed in stoppedAt.
*/
Program *ParseMacro(char *expr, char **msg, char **stoppedAt)
{
    Program *prog;

    BeginCreatingProgram();

    /* call yyparse to parse the string and check for success.  If the parse
       failed, return the error message and string index (the grammar aborts
       parsing at the first error) */
    InPtr = expr;
    if (yyparse()) {
        *msg = ErrMsg;
        *stoppedAt = InPtr;
        FreeProgram(FinishCreatingProgram());
        return NULL;
    }

    /* get the newly created program */
    prog = FinishCreatingProgram();

    /* parse succeeded */
    *msg = "";
    *stoppedAt = InPtr;
    return prog;
}


static int yylex(void)
{
    int i, len;
    Symbol *s;
    static DataValue value = {NO_TAG, {0}};
    static char escape[] = "\\\"ntbrfave";
#ifdef EBCDIC_CHARSET
    static char replace[] = "\\\"\n\t\b\r\f\a\v\x27"; /* EBCDIC escape */
#else
    static char replace[] = "\\\"\n\t\b\r\f\a\v\x1B"; /* ASCII escape */
#endif

    /* skip whitespace, backslash-newline combinations, and comments, which are
       all considered whitespace */
    for (;;) {
        if (*InPtr == '\\' && *(InPtr + 1) == '\n')
            InPtr += 2;
        else if (*InPtr == ' ' || *InPtr == '\t')
            InPtr++;
        else if (*InPtr == '#')
            while (*InPtr != '\n' && *InPtr != '\0') {
                /* Comments stop at escaped newlines */
                if (*InPtr == '\\' && *(InPtr + 1) == '\n') {
                    InPtr += 2;
                    break;
                }
                InPtr++;
            }        else
            break;
    }


    /* return end of input at the end of the string */
    if (*InPtr == '\0') {
        return 0;
    }

    /* process number tokens */
    if (isdigit((unsigned char)*InPtr))  { /* number */
        char name[28];
        sscanf(InPtr, "%d%n", &value.val.n, &len);
        sprintf(name, "const %d", value.val.n);
        InPtr += len;
        value.tag = INT_TAG;
        if ((yylval.sym=LookupSymbol(name)) == NULL)
            yylval.sym = InstallSymbol(name, CONST_SYM, value);
        return NUMBER;
    }

    /* process symbol tokens.  "define" is a special case not handled
       by this parser, considered end of input.  Another special case
       is action routine names which are allowed to contain '-' despite
       the ambiguity, handled in matchesActionRoutine. */
    if (isalpha((unsigned char)*InPtr) || *InPtr == '$') {
        if ((s=matchesActionRoutine(&InPtr)) == NULL) {
            char symName[MAX_SYM_LEN+1], *p = symName;
            *p++ = *InPtr++;
            while (isalnum((unsigned char)*InPtr) || *InPtr=='_') {
                if (p >= symName + MAX_SYM_LEN)
                    InPtr++;
                else
                    *p++ = *InPtr++;
            }
            *p = '\0';
            if (!strcmp(symName, "while")) return WHILE;
            if (!strcmp(symName, "if")) return IF;
            if (!strcmp(symName, "else")) return ELSE;
            if (!strcmp(symName, "for")) return FOR;
            if (!strcmp(symName, "break")) return BREAK;
            if (!strcmp(symName, "continue")) return CONTINUE;
            if (!strcmp(symName, "return")) return RETURN;
            if (!strcmp(symName, "in")) return IN;
            if (!strcmp(symName, "$args")) return ARG_LOOKUP;
            if (!strcmp(symName, "delete") && follow_non_whitespace('(', SYMBOL, DELETE) == DELETE) return DELETE;
            if (!strcmp(symName, "define")) {
                InPtr -= 6;
                return 0;
            }
            if ((s=LookupSymbol(symName)) == NULL) {
                s = InstallSymbol(symName, symName[0]=='$' ?
                        (((symName[1] > '0' && symName[1] <= '9') && symName[2] == 0) ?
                        ARG_SYM : GLOBAL_SYM) : LOCAL_SYM, value);
                s->value.tag = NO_TAG;
            }
        }
        yylval.sym = s;
        return SYMBOL;
    }

    /* Process quoted strings with embedded escape sequences:
         For backslashes we recognise hexadecimal values with initial 'x' such
       as "\x1B"; octal value (upto 3 oct digits with a possible leading zero)
       such as "\33", "\033" or "\0033", and the C escapes: \", \', \n, \t, \b,
       \r, \f, \a, \v, and the added \e for the escape character, as for REs.
         Disallow hex/octal zero values (NUL): instead ignore the introductory
       backslash, eg "\x0xyz" becomes "x0xyz" and "\0000hello" becomes
       "0000hello". */

    if (*InPtr == '\"') {
        char string[MAX_STRING_CONST_LEN], *p = string;
        char *backslash;
        InPtr++;
        while (*InPtr != '\0' && *InPtr != '\"' && *InPtr != '\n') {
            if (p >= string + MAX_STRING_CONST_LEN) {
                InPtr++;
                continue;
            }
            if (*InPtr == '\\') {
                backslash = InPtr;
                InPtr++;
                if (*InPtr == '\n') {
                    InPtr++;
                    continue;
                }
                if (*InPtr == 'x') {
                    /* a hex introducer */
                    int hexValue = 0;
                    const char *hexDigits = "0123456789abcdef";
                    const char *hexD;
                    InPtr++;
                    if (*InPtr == '\0' ||
                        (hexD = strchr(hexDigits, tolower(*InPtr))) == NULL) {
                        *p++ = 'x';
                    }
                    else {
                        hexValue = hexD - hexDigits;
                        InPtr++;
                        /* now do we have another digit? only accept one more */
                        if (*InPtr != '\0' &&
                            (hexD = strchr(hexDigits,tolower(*InPtr))) != NULL){
                          hexValue = hexD - hexDigits + (hexValue << 4);
                          InPtr++;
                        }
                        if (hexValue != 0) {
                            *p++ = (char)hexValue;
                        }
                        else {
                            InPtr = backslash + 1; /* just skip the backslash */
                        }
                    }
                    continue;
                }
                /* the RE documentation requires \0 as the octal introducer;
                   here you can start with any octal digit, but you are only
                   allowed up to three (or four if the first is '0'). */
                if ('0' <= *InPtr && *InPtr <= '7') {
                    if (*InPtr == '0') {
                        InPtr++;  /* octal introducer: don't count this digit */
                    }
                    if ('0' <= *InPtr && *InPtr <= '7') {
                        /* treat as octal - first digit */
                        char octD = *InPtr++;
                        int octValue = octD - '0';
                        if ('0' <= *InPtr && *InPtr <= '7') {
                            /* second digit */
                            octD = *InPtr++;
                            octValue = (octValue << 3) + octD - '0';
                            /* now do we have another digit? can we add it?
                               if value is going to be too big for char (greater
                               than 0377), stop converting now before adding the
                               third digit */
                            if ('0' <= *InPtr && *InPtr <= '7' &&
                                octValue <= 037) {
                                /* third digit is acceptable */
                                octD = *InPtr++;
                                octValue = (octValue << 3) + octD - '0';
                            }
                        }
                        if (octValue != 0) {
                            *p++ = (char)octValue;
                        }
                        else {
                            InPtr = backslash + 1; /* just skip the backslash */
                        }
                    }
                    else { /* \0 followed by non-digits: go back to 0 */
                        InPtr = backslash + 1; /* just skip the backslash */
                    }
                    continue;
                }
                for (i=0; escape[i]!='\0'; i++) {
                    if (escape[i] == *InPtr) {
                        *p++ = replace[i];
                        InPtr++;
                        break;
                    }
                }
                /* if we get here, we didn't recognise the character after
                   the backslash: just copy it next time round the loop */
            }
            else {
                *p++= *InPtr++;
            }
        }
        *p = '\0';
        InPtr++;
        yylval.sym = InstallStringConstSymbol(string);
        return STRING;
    }

    /* process remaining two character tokens or return single char as token */
    switch(*InPtr++) {
    case '>':   return follow('=', GE, GT);
    case '<':   return follow('=', LE, LT);
    case '=':   return follow('=', EQ, '=');
    case '!':   return follow('=', NE, NOT);
    case '+':   return follow2('+', INCR, '=', ADDEQ, '+');
    case '-':   return follow2('-', DECR, '=', SUBEQ, '-');
    case '|':   return follow2('|', OR, '=', OREQ, '|');
    case '&':   return follow2('&', AND, '=', ANDEQ, '&');
    case '*':   return follow2('*', POW, '=', MULEQ, '*');
    case '/':   return follow('=', DIVEQ, '/');
    case '%':   return follow('=', MODEQ, '%');
    case '^':   return POW;
    default:    return *(InPtr-1);
    }
}

/*
** look ahead for >=, etc.
*/
static int follow(char expect, int yes, int no)
{
    if (*InPtr++ == expect)
        return yes;
    InPtr--;
    return no;
}
static int follow2(char expect1, int yes1, char expect2, int yes2, int no)
{
    char next = *InPtr++;
    if (next == expect1)
        return yes1;
    if (next == expect2)
        return yes2;
    InPtr--;
    return no;
}

static int follow_non_whitespace(char expect, int yes, int no)
{
    char *localInPtr = InPtr;

    while (1) {
        if (*localInPtr == ' ' || *localInPtr == '\t') {
            ++localInPtr;
        }
        else if (*localInPtr == '\\' && *(localInPtr + 1) == '\n') {
            localInPtr += 2;
        }
        else if (*localInPtr == expect) {
            return(yes);
        }
        else {
            return(no);
        }
    }
}

/*
** Look (way) ahead for hyphenated routine names which begin at inPtr.  A
** hyphenated name is allowed if it is pre-defined in the global symbol
** table.  If a matching name exists, returns the symbol, and update "inPtr".
**
** I know this is horrible language design, but existing nedit action routine
** names contain hyphens.  Handling them here in the lexical analysis process
** is much easier than trying to deal with it in the parser itself.  (sorry)
*/
static Symbol *matchesActionRoutine(char **inPtr)
{
    char *c, *symPtr;
    int hasDash = False;
    char symbolName[MAX_SYM_LEN+1];
    Symbol *s;

    symPtr = symbolName;
    for (c = *inPtr; isalnum((unsigned char)*c) || *c=='_' ||
            ( *c=='-' && isalnum((unsigned char)(*(c+1)))); c++) {
        if (*c == '-')
            hasDash = True;
        *symPtr++ = *c;
    }
    if (!hasDash)
        return NULL;
    *symPtr = '\0';
    s = LookupSymbol(symbolName);
    if (s != NULL)
        *inPtr = c;
    return s;
}

/*
** Called by yacc to report errors (just stores for returning when
** parsing is aborted.  The error token action is to immediate abort
** parsing, so this message is immediately reported to the caller
** of ParseExpr)
*/
static int yyerror(char *s)
{
    ErrMsg = s;
    return 0;
}
#line 1473 "y.tab.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 1:
#line 89 "parse.y"
	{
                ADD_OP(OP_RETURN_NO_VAL); return 0;
            }
#line 2148 "y.tab.c"
break;
case 2:
#line 92 "parse.y"
	{
                ADD_OP(OP_RETURN_NO_VAL); return 0;
            }
#line 2155 "y.tab.c"
break;
case 3:
#line 95 "parse.y"
	{
                ADD_OP(OP_RETURN_NO_VAL); return 0;
            }
#line 2162 "y.tab.c"
break;
case 4:
#line 98 "parse.y"
	{
                return 1;
            }
#line 2169 "y.tab.c"
break;
case 11:
#line 110 "parse.y"
	{
                SET_BR_OFF(yystack.l_mark[-3].inst, GetPC());
            }
#line 2176 "y.tab.c"
break;
case 12:
#line 113 "parse.y"
	{
                SET_BR_OFF(yystack.l_mark[-6].inst, (yystack.l_mark[-2].inst+1)); SET_BR_OFF(yystack.l_mark[-2].inst, GetPC());
            }
#line 2183 "y.tab.c"
break;
case 13:
#line 116 "parse.y"
	{
                ADD_OP(OP_BRANCH); ADD_BR_OFF(yystack.l_mark[-5].inst);
                SET_BR_OFF(yystack.l_mark[-3].inst, GetPC()); FillLoopAddrs(GetPC(), yystack.l_mark[-5].inst);
            }
#line 2191 "y.tab.c"
break;
case 14:
#line 120 "parse.y"
	{
                FillLoopAddrs(GetPC()+2+(yystack.l_mark[-3].inst-(yystack.l_mark[-5].inst+1)), GetPC());
                SwapCode(yystack.l_mark[-5].inst+1, yystack.l_mark[-3].inst, GetPC());
                ADD_OP(OP_BRANCH); ADD_BR_OFF(yystack.l_mark[-7].inst); SET_BR_OFF(yystack.l_mark[-5].inst, GetPC());
            }
#line 2200 "y.tab.c"
break;
case 15:
#line 125 "parse.y"
	{
                Symbol *iterSym = InstallIteratorSymbol();
                ADD_OP(OP_BEGIN_ARRAY_ITER); ADD_SYM(iterSym);
                ADD_OP(OP_ARRAY_ITER); ADD_SYM(yystack.l_mark[-3].sym); ADD_SYM(iterSym); ADD_BR_OFF(0);
            }
#line 2209 "y.tab.c"
break;
case 16:
#line 130 "parse.y"
	{
                    ADD_OP(OP_BRANCH); ADD_BR_OFF(yystack.l_mark[-4].inst+2);
                    SET_BR_OFF(yystack.l_mark[-4].inst+5, GetPC());
                    FillLoopAddrs(GetPC(), yystack.l_mark[-4].inst+2);
            }
#line 2218 "y.tab.c"
break;
case 17:
#line 135 "parse.y"
	{
                ADD_OP(OP_BRANCH); ADD_BR_OFF(0);
                if (AddBreakAddr(GetPC()-1)) {
                    yyerror("break outside loop"); YYERROR;
                }
            }
#line 2228 "y.tab.c"
break;
case 18:
#line 141 "parse.y"
	{
                ADD_OP(OP_BRANCH); ADD_BR_OFF(0);
                if (AddContinueAddr(GetPC()-1)) {
                    yyerror("continue outside loop"); YYERROR;
                }
            }
#line 2238 "y.tab.c"
break;
case 19:
#line 147 "parse.y"
	{
                ADD_OP(OP_RETURN);
            }
#line 2245 "y.tab.c"
break;
case 20:
#line 150 "parse.y"
	{
                ADD_OP(OP_RETURN_NO_VAL);
            }
#line 2252 "y.tab.c"
break;
case 21:
#line 154 "parse.y"
	{
                ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2259 "y.tab.c"
break;
case 22:
#line 157 "parse.y"
	{
                ADD_OP(OP_ADD); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2266 "y.tab.c"
break;
case 23:
#line 160 "parse.y"
	{
                ADD_OP(OP_SUB); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2273 "y.tab.c"
break;
case 24:
#line 163 "parse.y"
	{
                ADD_OP(OP_MUL); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2280 "y.tab.c"
break;
case 25:
#line 166 "parse.y"
	{
                ADD_OP(OP_DIV); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2287 "y.tab.c"
break;
case 26:
#line 169 "parse.y"
	{
                ADD_OP(OP_MOD); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2294 "y.tab.c"
break;
case 27:
#line 172 "parse.y"
	{
                ADD_OP(OP_BIT_AND); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2301 "y.tab.c"
break;
case 28:
#line 175 "parse.y"
	{
                ADD_OP(OP_BIT_OR); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-2].sym);
            }
#line 2308 "y.tab.c"
break;
case 29:
#line 178 "parse.y"
	{
                ADD_OP(OP_ARRAY_DELETE); ADD_IMMED(yystack.l_mark[-1].nArgs);
            }
#line 2315 "y.tab.c"
break;
case 30:
#line 181 "parse.y"
	{
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2322 "y.tab.c"
break;
case 31:
#line 184 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(1); ADD_IMMED(yystack.l_mark[-3].nArgs);
                ADD_OP(OP_ADD);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2331 "y.tab.c"
break;
case 32:
#line 189 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(1); ADD_IMMED(yystack.l_mark[-3].nArgs);
                ADD_OP(OP_SUB);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2340 "y.tab.c"
break;
case 33:
#line 194 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(1); ADD_IMMED(yystack.l_mark[-3].nArgs);
                ADD_OP(OP_MUL);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2349 "y.tab.c"
break;
case 34:
#line 199 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(1); ADD_IMMED(yystack.l_mark[-3].nArgs);
                ADD_OP(OP_DIV);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2358 "y.tab.c"
break;
case 35:
#line 204 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(1); ADD_IMMED(yystack.l_mark[-3].nArgs);
                ADD_OP(OP_MOD);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2367 "y.tab.c"
break;
case 36:
#line 209 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(1); ADD_IMMED(yystack.l_mark[-3].nArgs);
                ADD_OP(OP_BIT_AND);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2376 "y.tab.c"
break;
case 37:
#line 214 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(1); ADD_IMMED(yystack.l_mark[-3].nArgs);
                ADD_OP(OP_BIT_OR);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-3].nArgs);
            }
#line 2385 "y.tab.c"
break;
case 38:
#line 219 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(0); ADD_IMMED(yystack.l_mark[-2].nArgs);
                ADD_OP(OP_INCR);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-2].nArgs);
            }
#line 2394 "y.tab.c"
break;
case 39:
#line 224 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(0); ADD_IMMED(yystack.l_mark[-2].nArgs);
                ADD_OP(OP_DECR);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-2].nArgs);
            }
#line 2403 "y.tab.c"
break;
case 40:
#line 229 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(0); ADD_IMMED(yystack.l_mark[-1].nArgs);
                ADD_OP(OP_INCR);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-1].nArgs);
            }
#line 2412 "y.tab.c"
break;
case 41:
#line 234 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF_ASSIGN_SETUP); ADD_IMMED(0); ADD_IMMED(yystack.l_mark[-1].nArgs);
                ADD_OP(OP_DECR);
                ADD_OP(OP_ARRAY_ASSIGN); ADD_IMMED(yystack.l_mark[-1].nArgs);
            }
#line 2421 "y.tab.c"
break;
case 42:
#line 239 "parse.y"
	{
                ADD_OP(OP_SUBR_CALL);
                ADD_SYM(PromoteToGlobal(yystack.l_mark[-3].sym)); ADD_IMMED(yystack.l_mark[-1].nArgs);
            }
#line 2429 "y.tab.c"
break;
case 43:
#line 243 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym); ADD_OP(OP_INCR);
                ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2437 "y.tab.c"
break;
case 44:
#line 247 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[-1].sym); ADD_OP(OP_INCR);
                ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-1].sym);
            }
#line 2445 "y.tab.c"
break;
case 45:
#line 251 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym); ADD_OP(OP_DECR);
                ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2453 "y.tab.c"
break;
case 46:
#line 255 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[-1].sym); ADD_OP(OP_DECR);
                ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-1].sym);
            }
#line 2461 "y.tab.c"
break;
case 47:
#line 260 "parse.y"
	{
                yyval.sym = yystack.l_mark[0].sym; ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2468 "y.tab.c"
break;
case 48:
#line 264 "parse.y"
	{
                yyval.inst = GetPC();
            }
#line 2475 "y.tab.c"
break;
case 49:
#line 267 "parse.y"
	{
                yyval.inst = GetPC();
            }
#line 2482 "y.tab.c"
break;
case 50:
#line 270 "parse.y"
	{
                yyval.inst = GetPC();
            }
#line 2489 "y.tab.c"
break;
case 51:
#line 274 "parse.y"
	{
                yyval.nArgs = 0;
            }
#line 2496 "y.tab.c"
break;
case 52:
#line 277 "parse.y"
	{
                yyval.nArgs = 1;
            }
#line 2503 "y.tab.c"
break;
case 53:
#line 280 "parse.y"
	{
                yyval.nArgs = yystack.l_mark[-2].nArgs + 1;
            }
#line 2510 "y.tab.c"
break;
case 55:
#line 285 "parse.y"
	{
                ADD_OP(OP_CONCAT);
            }
#line 2517 "y.tab.c"
break;
case 56:
#line 289 "parse.y"
	{
                    ADD_OP(OP_PUSH_ARRAY_SYM); ADD_SYM(yystack.l_mark[0].sym); ADD_IMMED(1);
                }
#line 2524 "y.tab.c"
break;
case 57:
#line 292 "parse.y"
	{
                    ADD_OP(OP_ARRAY_REF); ADD_IMMED(yystack.l_mark[-1].nArgs);
                }
#line 2531 "y.tab.c"
break;
case 58:
#line 296 "parse.y"
	{
                ADD_OP(OP_PUSH_ARRAY_SYM); ADD_SYM(yystack.l_mark[0].sym); ADD_IMMED(0);
            }
#line 2538 "y.tab.c"
break;
case 59:
#line 299 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF); ADD_IMMED(yystack.l_mark[-1].nArgs);
            }
#line 2545 "y.tab.c"
break;
case 60:
#line 303 "parse.y"
	{
                yyval.inst = GetPC();
            }
#line 2552 "y.tab.c"
break;
case 61:
#line 307 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2559 "y.tab.c"
break;
case 62:
#line 310 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2566 "y.tab.c"
break;
case 63:
#line 313 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2573 "y.tab.c"
break;
case 64:
#line 316 "parse.y"
	{
                ADD_OP(OP_SUBR_CALL);
                ADD_SYM(PromoteToGlobal(yystack.l_mark[-3].sym)); ADD_IMMED(yystack.l_mark[-1].nArgs);
                ADD_OP(OP_FETCH_RET_VAL);
            }
#line 2582 "y.tab.c"
break;
case 66:
#line 322 "parse.y"
	{
               ADD_OP(OP_PUSH_ARG);
            }
#line 2589 "y.tab.c"
break;
case 67:
#line 325 "parse.y"
	{
               ADD_OP(OP_PUSH_ARG_COUNT);
            }
#line 2596 "y.tab.c"
break;
case 68:
#line 328 "parse.y"
	{
               ADD_OP(OP_PUSH_ARG_ARRAY);
            }
#line 2603 "y.tab.c"
break;
case 69:
#line 331 "parse.y"
	{
                ADD_OP(OP_ARRAY_REF); ADD_IMMED(yystack.l_mark[-1].nArgs);
            }
#line 2610 "y.tab.c"
break;
case 70:
#line 334 "parse.y"
	{
                ADD_OP(OP_ADD);
            }
#line 2617 "y.tab.c"
break;
case 71:
#line 337 "parse.y"
	{
                ADD_OP(OP_SUB);
            }
#line 2624 "y.tab.c"
break;
case 72:
#line 340 "parse.y"
	{
                ADD_OP(OP_MUL);
            }
#line 2631 "y.tab.c"
break;
case 73:
#line 343 "parse.y"
	{
                ADD_OP(OP_DIV);
            }
#line 2638 "y.tab.c"
break;
case 74:
#line 346 "parse.y"
	{
                ADD_OP(OP_MOD);
            }
#line 2645 "y.tab.c"
break;
case 75:
#line 349 "parse.y"
	{
                ADD_OP(OP_POWER);
            }
#line 2652 "y.tab.c"
break;
case 76:
#line 352 "parse.y"
	{
                ADD_OP(OP_NEGATE);
            }
#line 2659 "y.tab.c"
break;
case 77:
#line 355 "parse.y"
	{
                ADD_OP(OP_GT);
            }
#line 2666 "y.tab.c"
break;
case 78:
#line 358 "parse.y"
	{
                ADD_OP(OP_GE);
            }
#line 2673 "y.tab.c"
break;
case 79:
#line 361 "parse.y"
	{
                ADD_OP(OP_LT);
            }
#line 2680 "y.tab.c"
break;
case 80:
#line 364 "parse.y"
	{
                ADD_OP(OP_LE);
            }
#line 2687 "y.tab.c"
break;
case 81:
#line 367 "parse.y"
	{
                ADD_OP(OP_EQ);
            }
#line 2694 "y.tab.c"
break;
case 82:
#line 370 "parse.y"
	{
                ADD_OP(OP_NE);
            }
#line 2701 "y.tab.c"
break;
case 83:
#line 373 "parse.y"
	{
                ADD_OP(OP_BIT_AND);
            }
#line 2708 "y.tab.c"
break;
case 84:
#line 376 "parse.y"
	{
                ADD_OP(OP_BIT_OR);
            }
#line 2715 "y.tab.c"
break;
case 85:
#line 379 "parse.y"
	{
                ADD_OP(OP_AND); SET_BR_OFF(yystack.l_mark[-1].inst, GetPC());
            }
#line 2722 "y.tab.c"
break;
case 86:
#line 382 "parse.y"
	{
                ADD_OP(OP_OR); SET_BR_OFF(yystack.l_mark[-1].inst, GetPC());
            }
#line 2729 "y.tab.c"
break;
case 87:
#line 385 "parse.y"
	{
                ADD_OP(OP_NOT);
            }
#line 2736 "y.tab.c"
break;
case 88:
#line 388 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym); ADD_OP(OP_INCR);
                ADD_OP(OP_DUP); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2744 "y.tab.c"
break;
case 89:
#line 392 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[-1].sym); ADD_OP(OP_DUP);
                ADD_OP(OP_INCR); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-1].sym);
            }
#line 2752 "y.tab.c"
break;
case 90:
#line 396 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[0].sym); ADD_OP(OP_DECR);
                ADD_OP(OP_DUP); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[0].sym);
            }
#line 2760 "y.tab.c"
break;
case 91:
#line 400 "parse.y"
	{
                ADD_OP(OP_PUSH_SYM); ADD_SYM(yystack.l_mark[-1].sym); ADD_OP(OP_DUP);
                ADD_OP(OP_DECR); ADD_OP(OP_ASSIGN); ADD_SYM(yystack.l_mark[-1].sym);
            }
#line 2768 "y.tab.c"
break;
case 92:
#line 404 "parse.y"
	{
                ADD_OP(OP_IN_ARRAY);
            }
#line 2775 "y.tab.c"
break;
case 93:
#line 408 "parse.y"
	{
            yyval.inst = GetPC(); StartLoopAddrList();
        }
#line 2782 "y.tab.c"
break;
case 94:
#line 412 "parse.y"
	{
            StartLoopAddrList(); yyval.inst = GetPC();
        }
#line 2789 "y.tab.c"
break;
case 95:
#line 416 "parse.y"
	{
            ADD_OP(OP_BRANCH); yyval.inst = GetPC(); ADD_BR_OFF(0);
        }
#line 2796 "y.tab.c"
break;
case 96:
#line 420 "parse.y"
	{
            ADD_OP(OP_BRANCH_NEVER); yyval.inst = GetPC(); ADD_BR_OFF(0);
        }
#line 2803 "y.tab.c"
break;
case 97:
#line 423 "parse.y"
	{
            ADD_OP(OP_BRANCH_FALSE); yyval.inst = GetPC(); ADD_BR_OFF(0);
        }
#line 2810 "y.tab.c"
break;
case 98:
#line 427 "parse.y"
	{
            ADD_OP(OP_DUP); ADD_OP(OP_BRANCH_FALSE); yyval.inst = GetPC();
            ADD_BR_OFF(0);
        }
#line 2818 "y.tab.c"
break;
case 99:
#line 432 "parse.y"
	{
            ADD_OP(OP_DUP); ADD_OP(OP_BRANCH_TRUE); yyval.inst = GetPC();
            ADD_BR_OFF(0);
        }
#line 2826 "y.tab.c"
break;
#line 2828 "y.tab.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
